
.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

  
include \masm32\include\windows.inc
include     \masm32\macros\timers.asm      
include     \masm32\macros\macros.asm    
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\msvcrt.inc
include \masm32\include\shlwapi.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\msvcrt.lib
includelib \masm32\lib\shlwapi.lib
InStringL proto :DWORD, :DWORD


     CTEXT MACRO text:VARARG
            LOCAL TxtName
              .data
               TxtName BYTE text,0
              .code
            EXITM <ADDR TxtName>
     ENDM
;    
.data
Mainstr db "hello there stranger hows it going",0
Substrx  db "hows",0

.data?
NTstrstr dd ?

.code
start:
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke crt_strstr,addr Mainstr,addr Substrx
counter_end
fn MessageBox,0,str$(eax),"timing msvcrt strstr",MB_OK 


LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke StrStr,addr Mainstr,addr Substrx
counter_end
fn MessageBox,0,str$(eax),"timing strstr",MB_OK 


LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke InString,1,addr Mainstr,addr Substrx
counter_end
fn MessageBox,0,str$(eax),"timing InString",MB_OK 

LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke InStringL,addr Mainstr,addr Substrx
counter_end
fn MessageBox,0,str$(eax),"timing InStringL",MB_OK


;----------------------------------------
;Undocumented Nt strstr? doesn't work
;--------------------------------------
comment ~
invoke LoadLibrary,CTEXT("ntdll.dll")
invoke GetProcAddress,eax,CTEXT("strstr")
mov NTstrstr,eax

LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
push offset Substrx
push offset Mainstr
call NTstrstr
counter_end
fn MessageBox,0,str$(eax),"timing ntdll strstr",MB_OK
~
invoke ExitProcess,0

; InString searches (case sensitive) for a substring
; in a larger string and if it is found, it returns its
; address in eax.  
; If the substring is not found, it returns zero in eax.
; Usage: push offset Pattern
;        push offset Source
;        call InStringL
; [B]Caution:[/B]This code is hard to read  
OPTION PROLOGUE:NONE                    ; turn it off
OPTION EPILOGUE:NONE                    ;
Align 16                                ; Align 16 before the proc
InStringL proc lpSource:DWORD, lpPattern:DWORD
         db    3Eh                     ; ds: prefix
         mov   eax, [esp+8]            ; ecx->lpPattern
         sub   esp, 2*4                ; room to save registers and lenght of substring
         db    3Eh                     ;
         mov   edx, [esp+2*4]          ; edx-> return address
         db    3Eh                     ;
         mov   ecx, [eax]              ; get dword from substring
         db    3Eh                     ;
         mov   [esp+2*4], ebx          ; save register ebx
         movzx ebx, cl                 ; ebx->the 1st byte of substring
         db    3Eh                     ;
         mov   [esp+4*4], edx          ; save return address
         imul  ebx, 1010101h           ; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
         db    3Eh                     ;   (if the 1st byte of substring is "w")
         mov   [esp], esi              ;          
         lea   esi, [eax-1]            ; esi-> lpPattern-1
         mov   [esp+1*4], edi          ; save register edi
         mov   edx, 80808080h          ;
         mov   edi, [esp+3*4]          ; edi-> lpSource
         mov   [esp+3*4], ebp          ; save register ebp
         mov   ebp, 0FEFEFEFFh         ; ebp=0FEFEFEFFh
LoopS1:                                 ; my strlen with substring
         add   eax, 4                  ; ecx->lpPattern
         add   ecx, ebp                ; ebp=0FEFEFEFFh
         test  edx, ecx                ;
         mov   ecx, [eax]              ; get dword from substring
         je    LoopS1                  ; 2 clocks per 4 bytes
         cmp   byte ptr [eax-4], 0     ;
         je    S1_minus4               ;
         cmp   byte ptr [eax-4+1], 0   ;
         je    S1_minus3               ;
         cmp   byte ptr [eax-4+2], 0   ;
         je    S1_minus2               ;
         cmp   byte ptr [eax-4+3], 0   ;
         jne   LoopS1                  ; if not zeroes loop again
         sub   eax, 2                  ;
S1:                                     ;
         mov   ebp, [edi]              ;
         sub   eax, esi                ; end my strlen with substring
         mov   ecx, -4                 ;
         push  eax                     ; save len of substring in variable
BytesScan:                              ;
         db    3Eh                     ; ds: prefix
         lea   edx, [ebp-1010101h]     ; searching the 1st byte of substring or/and zero
         xor   ebp, ebx                ; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
         db    3Eh                     ;   (if the 1st byte of substring is "w")
         add   edi, 4                  ;              
         sub   ebp, 1010101h           ;
         or    edx, ebp                ; testing the 1st byte of substring and 0
         db    3Eh                     ;   simultaneously in the larger string
         mov   ebp, [edi]              ;  
         and   edx, 80808080h          ;
         je    BytesScan               ; 4 clocks per 4 bytes
SrchNextByte:                           ;
         cmp   [edi+ecx], bl           ; bl = 77h -> ASCII code of "w
         je    StartCmp                ;   (if the 1st byte of substring is "w")
         cmp   byte ptr [edi+ecx], 0   ; is it the end of the larger string?
         je    ExitP                   ; exit
ToNext:                                 ;
         inc   ecx                     ; ecx-> -4 to 0
         jne   SrchNextByte            ;
         mov   ebp, [edi]              ; restoring ebp for ByteScan
         sub   ecx, 4                  ; ecx = -4
         jc    BytesScan               ; loop again
align 16                                ;
S1_minus4:                              ;
         db    3Eh                     ; ds: prefix
         sub   eax, 5                  ;
         jno   S1                      ;
S1_minus3:                              ;
         sub   eax, 4                  ;
         jno   S1                      ;
S1_minus2:                              ;
         sub   eax, 3                  ;
         jno   S1                      ;
StartCmp:                               ; comparing next bytes from substring
         mov   edx,  [esp]             ; edx-> len of substring
         lea   ebp, [edi+ecx]          ; ebp=edi+ecx -> as a base register
         movzx eax, byte ptr [esi+edx] ; comparing rest bytes
         dec   edx                     ;
         je    ExitP                   ; exit
CmpNext:                                ;
         cmp   [ebp+edx], al           ; ebp->lp to current 1st byte in the larger string
         jne   ToNext                  ;
         movzx eax, byte ptr [esi+edx] ; get next byte
         dec   edx                     ;
         jne   CmpNext                 ; 2 clocks per byte
ExitP:                                  ;
         mov   esi, [esp+1*4]          ; restoring register esi
         cmp   edx, 1                  ; if edx= 0 mask = 0FFFFFFFFh else mask=0
         sbb   eax, eax                ; eax->mask 0 or 0FFFFFFFFh
         mov   edi, [esp+2*4]          ; restoring register edi
         and   eax, ebp                ; eax->lp 1st occurrence in large string or zero
         mov   ebx, [esp+3*4]          ; restoring register ebx
         mov   ebp, [esp+4*4]          ; restoring register ebp
         add   esp, 5*4                ; restoring register esp
         ret                           ; faster return then ret  2*4
InStringL endp
end start